EDIT - feature request #9507

Add ratioTo structure to Character
03/03/2021 10:36 AM - Andreas Miiller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdm Estimated time: 0:00 hour
Target version: Release 5.22

Severity: normal

Description

Some characters handle the ratio between two structures, e.g. length ratio between corolla and calyx.
For this we need an extra attribute ratioToStructure.

Open question: do we also need a ratioToStructor-modifier?

Related issues:
Precedes (10 days) EDIT - feature request #9537: Implement ratioToStructure i... Feedback

Associated revisions

Revision 38c2d4fc - 03/19/2021 02:04 PM - Andreas Miiller
ref #9507 add ratioToStructure to Character

Revision c3e0a69a - 03/19/2021 02:04 PM - Andreas Miiller

ref #9507 add ratioToStructure to test schema

Revision 6a1c1f85 - 03/19/2021 02:04 PM - Andreas Miiller
ref #9507 update test database ref integrity

History

#1 - 03/03/2021 10:38 AM - Andreas Miiller
NK:

Es gibt eine Reihe von Properties, die fur Relationen zwischen Strukturen genutzt werden und zu denen in unserem State Vokabular auch relationale
states existieren. Im Wesentlichen sind das: quantity, size, height, length, width and position; die Liste lieBe sich aber wohl noch erweitern.

Im states Vokabular gibt es in einem Fall (position) sogar ein eigenes Subvokabular "position relational", deshalb gibt es auch den dazugehérigen
Property term. Es ist m.E. aber 6konomischer, eine zusatzlichen modifier property relation in den property tree aufzunehmen und diese ggf. mit der
base property zu kombinieren.

Im Character Editor kénnte die Generierung eins solchen Merkmals so ablaufen:

Ich wahle eine Struktur, sagen wir "corolla" aus dem structure tree, dann eine property aus dem property tree, sagen wir "length" und, wenn ich eine
Relation im Character bilden will, zusétzlich die modifier property "relation". Wenn diese mitausgewahlt ist, kann ich eine weitere Struktur, sagen wir
"corolla" als Bezugsstruktur auswéhlen und aus dieser Kombination per >> einen Character im Character tree generieren, der dem Ausdruck
entspricht.

Im Details View des Character Tree brauchte es dazu unter den Feldern Structure und Property noch ein weiteres ausgegrautes Anzeigefeld "ratio
to" in dem die Bezugsstruktur, im obigen Beispiel angezeigt wird. Das label entspricht wie jetzt auch der Anzeige im Character tree und kann bei
Bedarf angepasst werden.

Ich kann weiterhin wahlen zwischen "Supports quantitative" oder "Supports Categorical Data"

Far relationalen characters als kategorische wéhle ich ein entsprechendes State-Vokabular.

Far quantitative characters kann ich die Auswahl von "statistical measures" unmittelbar benutzen, und entweder werden ratios direkt erhoben oder
aus den Werten von characters der einzelnen Strukturen (corolla length, calyx length) berechnet.

AM:

das klingt alles ziemlich straight forward und ich habe eigentlich keine Anmerkungen.

Einzig die Frage, ob wir diesen Property Modifier ,relational” wirklich brauchen. Wenn man grundsétzlich die Mdglichkeit anbietet, noch eine zweite
JratioTo“-Struktur hinzuzufiigen, dann ergibt sich das ja immanent, dass in diesem Fall die Property als Verhaltnis zu sehen ist.

Das kénnte sich héchstens andern, falls in Zukunft noch weitere Kombinationsméglichkeiten von Strukturen verwenden werden (z.B. die Summe der
Lange von 2 Strukturen, wenn diese sich einzeln schlecht messen lassen, einfach mal so als konstruiertes Beispiel, oder komplexere raumliche
Anordnungen mehrerer Strukturen). Aber das kdnnen wir dann ja noch anpassen, falls sowas wirklich mal auftreten sollte.
NK;

Den Property Modifier ,relational hatte ich deshalb fiir notwendig gehalten, weil ich auch jetzt schon 2 (oder mehr) Strukturen mit einer Property
verbinden kann, dies dann aber zu 2 (oder mehr) Merkmalen aus der Verbindung der Strukturen mit dieser Property fihrt.

AM:

verstehe ich das richtig, dass es sich dabei nur um eine Convenience-Methode handelt, mehrere Characters gleichzeitig anzulegen? Dann ist das ja
kein Widerspruch.

Da die RatioTo-Characters ja eher eine Ausnahme sind, wiirde ich die 2. Struktur hier auch erst im Nachhinein hinzufligen. Aber das sind eher
Ul-Details. Erstmal wichtig ist ja, ob das Modell so stimmt.

NK:
Ja, ist eine Convenience-Methode um mehrere Characters gleichzeitig anzulegen.
#2 - 03/17/2021 10:14 PM - Andreas Miiller

- Status changed from New to Resolved

- % Done changed from 0 to 50
ratioToStructure added.
If ratioTo modifier is also needed open new ticket.

#3 - 03/17/2021 10:14 PM - Andreas Miuller

- Tracker changed from bug to feature request

#4 - 03/17/2021 10:16 PM - Andreas Miuller

- Precedes feature request #9537 Implement ratio ToStructure in TaxEditor added

#5 - 03/19/2021 03:32 PM - Andreas Miiller
- Status changed from Resolved to Closed

- % Done changed from 50 to 100

#6 - 03/19/2021 03:32 PM - Andreas Miiller
- Target version changed from CDM UML 5.43 to Release 5.22

#7 - 03/19/2021 03:39 PM - Andreas Miuller
AM:

ratioTo ist modellseitig jetzt implementiert und muss nur noch im TaxEditor zur Verfigung gestellt werden.

Bislang habe ich jedoch nur eine Structure hinzugefugt. Evtl. miisste man auch noch einen Structure Modifier hinzufligen, da sich das natirlich auch
auf eine modifizierte Struktur beziehen kann, z.B. Verhaltnis zwischen oberem und unterem Blatt. Das wéare sogar die gleiche Struktur, nur der
Modifier wéare anders.

Da ich bezuglich der Semantik noch so ein bisschen Bauchschmerzen bei den Modifiern habe (letztlich sind Character ja nur dann vergleichbar, wenn
sie in Struktur UND Modifier Gbereinstimmen und wenn man Modifier viel verwendet entstehen somit wieder sehr viele mégliche Kombinationen)
habe ich das erstmal nicht gemacht. Wenn du denkst, dass es auf jeden Fall benétigt werden wird, sag Bescheid, dann kommt es ins nachste
Modellupdate mit dazu.
